function histogram = compute_meanshift_histogram(img, state, aspect_ratio, nbins)

% ellipse axes
axis_horiz = state(3);
axis_vert = round(state(3)*aspect_ratio);

[perim, mask] = generate_ellipse(size(img), state, aspect_ratio);

%figure(5), imagesc(mask)

%ellipse_perimeter = ellipse(state, aspect_ratio);
%ellipse_mask = create_ellipse_binary_mask(img,ellipse_perimeter);
col1 = img(:,:,1);
col2 = img(:,:,2);
col3 = img(:,:,3);

binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);
histogram = zeros(nbins(1),nbins(2),nbins(3));
for r=1:size(img,1)
    for c=1:size(img,2)
        if (mask(r, c) == 1)
            indx1 = floor( col1(r,c) / binwidth1 ) + 1;
            indx2 = floor( col2(r,c) / binwidth2 ) + 1;
            indx3 = floor( col3(r,c) / binwidth3 ) + 1;
            amt = kernel_func([(r - state(1)) / axis_vert, (c - state(2)) / axis_horiz]);
            histogram(indx1, indx2, indx3) = histogram(indx1, indx2, indx3) + amt;
        end
    end
end

% normalize histogram
histogram = histogram / sum(sum(sum(histogram)));




% kernel function; input is (r,c) normalized coordinates of point
% This code uses the Epanechnikov profile
function out = kernel_func(point)
p = norm(point);
%aaa = [point p]
if p>1, 
    out = 0;
    if p>1.1, error('assert');  end
else
    d = 2;
    cd = pi;
    out = (1-p)*(d+2) / (2*cd);
end

    

