% Try mean shift at three different scales, retaining the best
function new_state = compute_meanshift_vector_repeat_spatiogram_with_scale(spat_model, img, state, aspect_ratio, nbins)

scale = [0.9 1.0 1.1];
best_score = -1;

for i=1:3,
	statee = state;
	statee(3) = scale(i) * state(3);
    if is_state_in_bounds(statee, aspect_ratio, [size(img,1) size(img,2)]),
		[shift, niter] = compute_meanshift_vector_repeat_spatiogram(spat_model, img, statee, aspect_ratio, nbins);
		statee(1:2) = statee(1:2) + shift;
		spat_cand = compute_meanshift_spatiogram(img, statee, aspect_ratio, nbins);
		score = compare_spatiograms_meanshift(spat_cand, spat_model);
		if score>best_score,
            best_score = score;
            new_state = statee;
        end
	end
end