%--Clearing Workspace---%
clear all;
close all;
clc;
% constants
aspect_ratio = 1.2;
%aspect_ratio  = 1.4;
%aspect_ratio = 2.8;
nframes = 2;
nbins = [8,8,4];
nbins_edge = 8; %edge orientation histogram's bins
dir = 1;
size_range = [15,25];
alpha_value = 0.25;
gradmag_thresh =100;  % all gradmags above this value are saturated
select = 1; %if select is 2, Bhattacharyya coefficient.
%fname_base = 'melissa_head_frame_%04d.jpg';
%fname_base = 'c:/research/images/noellipse/seq_mg/img%03d.bmp';
fname_base = 'c:/research/images/noellipse/seq_sb/img%03d.bmp';
%fname_base = 'c:/research/images/noellipse/seq_sri/image%03d.ppm';
%fname_base = 'c:/research/images/noellipse/seq_sriram/img%03d.bmp';
%fname_base = 'c:/research/images/noellipse/sr_walk4/img%03d.bmp';
%fname_base = 'c:/research/images/Football/f_%03d.ppm';
%fname_base = 'c:/research/images/noellipse/football/f_%03d.ppm';
%fname_base = 'c:/research/images/noellipse/brag_walk/img%03d.bmp';
%fname_base = 'c:/research/images/noellipse/stb_walk/img%03d.bmp';
%fname_out = 'c:/guest/histogram-images-result/imgout%03d.bmp';
%fname_out = 'c:/img/test/text_only%03d.jpeg';
search_range = [6 6 .1];
img = double(imread(sprintf(fname_base,0)));
% img1 = img(:,:,1);
% imagesc(img1);
% colormap(gray);
% variables
%  [initial_state(1) initial_state(2)] = ginput(1);
%   initial_state(3) = 9;

initial_state = [60 48 18]; %starting point for seq_sb
%initial_state = [66 43 17]; %starting point for seq_mg
%initial_state = [163 125 35]; %starting point for sri1 from frame 20
%initial_state = [82 64 19]; %starting point for sri1 from frame 20.(160 X 120)
%initial_state = [120 307 19]; % starting point for football sequence.
%initial_state = [47 126 10]; % starting point for sriram sequence (320 x 240).
%initial_state = [76 55 10]; %starting point for sr_walk4 (160 X 120).
%initial_state = [111 25 9]; %starting point for brag_walk (160 X 120).
%initial_state = [92 67 10]; %starting point for stb_walk (160 X 120).
state(1) = round(initial_state(1));
state(2) = round(initial_state(2));
state(3) = initial_state(3);

% colormap(gray)

old_state = state;
img_color = colspace(img,1);
%model_histogram = compute_color_histogram(img_color,initial_state,aspect_ratio,nbins);
%model_histogram = compute_quadrant_histogram(img_color,initial_state,aspect_ratio,nbins);
model_histogram = compute_halo_histogram(img_color,initial_state,aspect_ratio,nbins);
%model_coocc = compute_cooccurrence_matrix(img_color,initial_state,aspect_ratio,dir);
%model_coocc = compute_g_cooccurrence_matrix(img,initial_state,aspect_ratio,dir);
%model_histogram = compute_edge_histogram(img_color,initial_state,aspect_ratio,nbins_edge);
%EO = gaborconvolve(img1, 4, 8, 3, 2, 0.65, 1.5);
%model_spatiogram = compute_color_spatiogram(img_color,initial_state,aspect_ratio,nbins);
%model_texture_histogram = compute_texture_histogram(img_color,initial_state,aspect_ratio);
%model_haar_histogram = compute_haar_histogram(img_color,initial_state,aspect_ratio);
%old_state = [50,199,22];
%state = [58,190,23];

%   spat1 = compute_color_spatiogram(img1,state1,aspect_ratio,nbins);
%   spat2 = compute_color_spatiogram(img2,state2,aspect_ratio,nbins);
%   spat3 = compute_color_spatiogram(img3,state3,aspect_ratio,nbins);
%   spat4 = compute_color_spatiogram(img4,state4,aspect_ratio,nbins);

for i=1:nframes,
    
    img  = double(imread(sprintf(fname_base, i)));
    % velocity prediction
    velocity = (state - old_state);
    old_state = state;
    state = state + [velocity(1:2) 0];
    
    % keep state in bounds
    state = keep_state_in_bounds(img,state,search_range,aspect_ratio,size_range);
    %convert image to required color space
    img_color = colspace(img,1);
    % compute likelihoods using each cue
    %likelihood_grad = compute_likelihood_gradmag(img, state, search_range, aspect_ratio, gradmag_thresh);
    likelihood_grad = compute_likelihood_graddot(img, state, search_range, aspect_ratio,gradmag_thresh);
    %likelihood_coocc = compute_likelihood_cooccurance(img_color, state, search_range, aspect_ratio,model_coocc,dir);
    %likelihood_coocc = compute_likelihood_g_cooccurrence(img, state, search_range, aspect_ratio,model_coocc,dir);
    %likelihood_color = compute_likelihood_edgehist(img_color, state, search_range, aspect_ratio,model_histogram,nbins_edge);
    %likelihood_color = compute_likelihood_colorhist(img_color, state, search_range, aspect_ratio,model_histogram,nbins,select);
    %likelihood_texture = compute_likelihood_texturehist(img_color, state, search_range, aspect_ratio,model_texture_histogram);
    %likelihood_haar = compute_likelihood_haarhist(img_color, state, search_range, aspect_ratio,model_haar_histogram);
    %likelihood_spatiogram = compute_likelihood_spatiogram(img_color,state,search_range,aspect_ratio,model_spatiogram,nbins);
    %likelihood_color = compute_likelihood_quadranthist(img_color, state, search_range, aspect_ratio,model_histogram,nbins,select);
    likelihood_color = compute_likelihood_halo(img_color, state, search_range, aspect_ratio,model_histogram,nbins,select);
    
    
    
    %  ---------% combine likelihoods--------------------%
    
    
    
    %likelihood = likelihood_grad + likelihood_spatiogram;
    %likelihood =   likelihood_grad + likelihood_haar;
    likelihood = likelihood_grad + likelihood_color;  
    %likelihood = likelihood_color;
    %likelihood =   likelihood_grad + likelihood_texture;
    %likelihood = likelihood_spatiogram;
    %likelihood = likelihood_coocc + likelihood_grad;
    %likelihood = likelihood_coocc + likelihood_color;
    %likelihood = likelihood_texture;
    %likelihood = likelihood_haar;
    %likelihood = likelihood_coocc;
    
    
    
    
    
    % set state to be the one that generates max overall likelihood
    maxlike = max(max(max(likelihood)));
    for j=1:size(likelihood,3),
        likee = squeeze(likelihood(:,:,j));
        [ii, jj] = find(likee == maxlike);
        
        
        if size(ii,1) >1,
            ii = ii(1);
        end
        if size(jj,1) >1.
            jj = jj(1);
        end
        
        % 
        if prod(size(ii)) > 0,
            state(1) = (state(1) + ii - search_range(1) - 1);
            state(2) = (state(2) + jj - search_range(2) - 1);
            %state(3) = (state(3)*(0.1*j + 0.8));
            state(3) = state(3) + (j-2);
        end
    end
    ypts(i) = state(1);
    xpts(i) = state(2);
    scal(i) = state(3);
    histogram = compute_halo_histogram(img_color,initial_state,aspect_ratio,nbins);
    model_histogram = update_halo(model_histogram,histogram, alpha_value);
    
    close all;
    ellipse_perimeter = ellipse(state,aspect_ratio);
    img1 = uint8(img);
    %     figuretmp=figure;
    figure(1);
    imagesc(img1);
    % colormap(gray)
    axis off;
    hold on;
    plot(ellipse_perimeter(1,:),ellipse_perimeter(2,:));
    hold off;
    
    
    
    %close all;
    %figtmp = figure;
    %figure(1),colormap(gray);
    %subplot(2,2,1)
    %imagesc(likelihood_spatiogram(:,:,1));
    %subplot(2,2,2)
    %imagesc(likelihood_spatiogram(:,:,2));
    %subplot(2,2,3)
    %imagesc(likelihood_spatiogram(:,:,3));
    % 
    %saveas(figtmp,sprintf('c:/test/likelihood_spat/likespat%03d.tiff',i))
    %waitforbuttonpress;
    %close all;
    %figtmp = figure;
    %figure(1),colormap(gray);
    %subplot(2,2,1)
    %imagesc(likelihood_grad(:,:,1));
    %subplot(2,2,2)
    %imagesc(likelihood_grad(:,:,2));
    %subplot(2,2,3)
    %imagesc(likelihood_grad(:,:,3));
    % 
    %saveas(figtmp,sprintf('c:/test/likelihood_grad/likegrad%03d.tiff',i))
    
    %saveas(figuretmp,sprintf(fname_out,i));
    pause(.05);
    
end