function histogram = compute_halo_histogram(img, state, aspect_ratio, nbins)
% histogram is 3D

ellipse_perimeter = ellipse(state, aspect_ratio);
ellipse_mask = create_ellipse_binary_mask(img,ellipse_perimeter);
new_state = state;
new_state(3) = new_state(3) + round(new_state(3)/2);
halo_ellipse_perimeter = ellipse(new_state, aspect_ratio);
halo_ellipse_mask = create_ellipse_binary_mask(img,halo_ellipse_perimeter);
col1 = img(:,:,1);
col2 = img(:,:,2);
col3 = img(:,:,3);

binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);
histogram.histogram = zeros(nbins(1),nbins(2),nbins(3));
histogram.halo = zeros(nbins(1),nbins(2),nbins(3));
% histogram2  = color histogram of current image
% histogram1  = color histogram of model
for r=1:size(img,1)
    for c=1:size(img,2)
        if (ellipse_mask(r, c) == 1)
            indx1 = floor( col1(r,c) / binwidth1 ) + 1;
            indx2 = floor( col2(r,c) / binwidth2 ) + 1;
            indx3 = floor( col3(r,c) / binwidth3 ) + 1;
            histogram.histogram(indx1, indx2, indx3) = histogram.histogram(indx1, indx2, indx3) + 1;
        end
        if (halo_ellipse_mask(r, c) == 1) && (ellipse_mask(r, c) ~= 1)
            halo_indx1 = floor( col1(r,c) / binwidth1 ) + 1;
            halo_indx2 = floor( col2(r,c) / binwidth2 ) + 1;
            halo_indx3 = floor( col3(r,c) / binwidth3 ) + 1;
            histogram.halo(halo_indx1, halo_indx2, halo_indx3) = histogram.halo(halo_indx1, halo_indx2, halo_indx3) + 1;
        end
    end
end