function [ellipse_perimeter]=ellipse(state,aspect_ratio)

%---------------------------------------------------------------------------------------------
% [ellipse_perimeter]=ellipse(state,aspect_ratio)
% This function computes rounded,connected points around
% the periphery of the ellipse.
%---------------------------------------------------------------------------------------------

warning off;

if (nargin == 1)
   aspect_ratio = 1;
elseif (aspect_ratio < 1)
   aspect_ratio = 1;
end
minax = state(3);
majax=round(aspect_ratio*minax);

x=0:minax;
for i=1:(minax+1)
    ycal(i)=round((majax/minax)*(minax^2-x(i)^2)^.5);
end

y=0:majax;
for i=1:(majax+1)
    xcal(i)=round((minax/majax)*(majax^2-y(i)^2)^.5);
end

xy=[];
inc=1;
for i=1:(minax+1)
    xy(1,inc)=x(i);
    xy(2,inc)=ycal(i);
    inc=inc+1;
end

for i=1:(majax+1)
    sz=size(xy);
    t=1;
    for k=1:sz(2)
        if (xy(1,k)==xcal(i))&&(xy(2,k)==y(i))
            t=0;
            break;
        end
    end
    if t==1
        xy(1,inc)=xcal(i);
        xy(2,inc)=y(i);
        inc=inc+1;
        t=0;
    end
end


xy(1,:)=sort(xy(1,:));
xy(2,:)=sort(xy(2,:));

xyp=[];

sz=size(xy);
for i=1:sz(2)
    xyp(1,i)=xy(1,i);
    xyp(2,i)=xy(2,sz(2)+1-i);

end


inc=sz(2)+1;
for i=(sz(2)-1):-1:1
    xyp(1,inc)=xyp(1,i);
    xyp(2,inc)=-xyp(2,i);
    inc=inc+1;

end


sz=size(xyp);
inc=sz(2)+1;
for i=(sz(2)-1):-1:2
    xyp(1,inc)=-xyp(1,i);
    xyp(2,inc)=xyp(2,i);
    inc=inc+1;

end
ellipse_perimeter(1,:) = xyp(1,:) + state(1);
ellipse_perimeter(2,:) = xyp(2,:) + state(2);
warning on;