% track mug using mean shift with spatiograms

% set this to one to disallow all spatiogram-specific parts of the
% computation
global just_do_histogram
just_do_histogram = 0;
color_convert = 1;
if color_convert,
    nbins = [8,8,4];
else
    nbins = [8,8,8];
end

initial_state = [48 60 18];  % initial state for seq_sb
%initial_state = [43 66 17];  % initial state for seq_mg
%initial_state = [307 120 19];  % initial state for football_rotated
%initial_state = [55 76 10];  % initial state for sriram_walking
%initial_state = [62 55 22];  % initial state for mug_video1
%initial_state = [63 34 18];  % initial state for mug_video2
%initial_state = [50 83 21];  % initial state for seq_sb (frame 100)
%initial_state = [40 77 21];  % initial state for seq_sb (frame 92)
%initial_state = [45 59 19];  % initial state for seq_villains2
%initial_state = [57 69 18];  % initial state for krispy_kreme
%initial_state = [54 67 18];  % initial state for krispy_kreme (frame 100)
%initial_state = [45 73 17];  % initial state for seq_cubicle
%initial_state = [38 88 17];  % initial state for seq_villains2 (frame 118)
state = initial_state;
aspect_ratio = 1.2;
%aspect_ratio = 1.4;  % football_rotated
%aspect_ratio = 2.8;  % sriram_walking
first_frame_num = 0; %92;%100;
last_frame_num = 100;
fname_base = 'c:/stb/data/images/headtracker/seq_sb/img%03d.bmp';
%fname_base = 'c:/stb/data/images/headtracker/seq_mg/img%03d.bmp';
%fname_base = 'c:/stb/data/images/comaniciu/football/rotated/f_%03d.ppm';  % football_rotated
%fname_base = 'c:/stb/data/images/sriram_walking/small/img%04d.ppm';  % sriram_walking
%fname_base = 'c:/stb/data/mugs/mugtest00_%02d.bmp';  % mugtest and mug_video1 share the same first frame
%fname_base = 'c:/stb/data/mugs/mug_video1_frame_%04d.bmp';
%fname_base = 'c:/stb/data/mugs/mug_video2_frame_%04d.bmp';
%fname_base = 'c:/stb/data/seq_villains2/imgnoellipse%03d.bmp';
%fname_base = 'c:/stb/data/krispy_kreme/krispy_kreme_frame_%04d.bmp';
%fname_base = 'c:/stb/data/seq_cubicle/imgnoellipse%03d.bmp';

frame_num = first_frame_num;
im = imread(sprintf(fname_base, frame_num));
im = double(im);
if color_convert,
    im = colspace(im);
end
if 0,
    % user clicks on figure to initialize
	figure(1), clf, hold on, imagesc(uint8(im)); axis('ij')
	[state(2) state(1)] = ginput(1);
	state(3) = 21;
end

show_ellipse_overlayed(im, state, aspect_ratio);
pause(1)

% compute histogram of model
spat_model = compute_meanshift_spatiogram(im, state, aspect_ratio, nbins);

states = [];
for frame_num=first_frame_num+1:last_frame_num,
    states = [states ; state];
    if mod(frame_num, 10)==0, disp(frame_num), end
    % load image
    im = imread(sprintf(fname_base, frame_num));
    im = double(im);
	if color_convert,
        im = colspace(im);
	end
%    figure(2), imagesc(uint8(im))

    % track
    new_state = compute_meanshift_vector_repeat_spatiogram_with_scale(spat_model, im, state, aspect_ratio, nbins);
    statee = new_state;
    statee(3) = 0.1*new_state(3) + 0.9*state(3);
    if ~is_state_in_bounds(statee, aspect_ratio, size(im)),
        statee(3) = new_state(3);
    end
    if ~is_state_in_bounds(statee, aspect_ratio, size(im)),
        statee = state;
        disp('assert: this shouldn''t happen')
    end
    state = statee;
%    [shift, niter]
%    state(1:2) = state(1:2) + shift;
    figure(2)
    show_ellipse_overlayed(im, state, aspect_ratio);
    pause(0.1)

    % get ready for next time (if you want model to change dynamically)
%    spat_model = compute_meanshift_spatiogram(im, state, aspect_ratio, nbins);
end

    


