% Given a color image, quantizes each pixel by setting it to the color of
% the histogram bin to which it belongs.
function newim = quantize_image_using_histogram_bins(im, nbins)

newim = zeros(size(im));
col1 = im(:,:,1);
col2 = im(:,:,2);
col3 = im(:,:,3);
binwidth1 = 256/nbins(1);
binwidth2 = 256/nbins(2);
binwidth3 = 256/nbins(3);
indx1 =floor( (col1-1) / binwidth1 ) + 1;
indx2 =floor( (col2-1) / binwidth2 ) + 1;
indx3 =floor( (col3-1) / binwidth3 ) + 1;
color1 = binwidth1 * ( indx1 - 0.5);
color2 = binwidth2 * ( indx2 - 0.5);
color3 = binwidth3 * ( indx3 - 0.5);
newim(:,:,1) = color1;
newim(:,:,2) = color2;
newim(:,:,3) = color3;
