% inputs:  an RGB image, state and aspect ratio of ellipse
% This function displays the image converted to grayscale, with the
% ellipse overlayed.
function show_ellipse_overlayed(img, state, aspect_ratio)

color = [255 0 0];

% % display image
% clf, colormap(gray)
% imagesc(img);
% hold on

% create binary overlay ellipse perimeter
[perim, mask] = generate_ellipse(size(img), state, aspect_ratio);
img_perim = zeros(size(img,1), size(img,2));
for i=1:size(perim,1),
    img_perim(perim(i,1), perim(i,2)) = 1;
end
if size(img,1)~=size(img_perim,1) | size(img,2)~=size(img_perim,2),
    error(sprintf('bad size:  %dx%d %dx%d, state=(%d,%d,%d)', size(img,1), size(img_perim,1), size(img,2), size(img_perim,2), state(1), state(2), state(3)));
end

% change pixel values in image
img(:,:,1) = img(:,:,1).*(1-img_perim) + img_perim*color(1);
img(:,:,2) = img(:,:,2).*(1-img_perim) + img_perim*color(2);
img(:,:,3) = img(:,:,3).*(1-img_perim) + img_perim*color(3);

clf
imagesc(uint8(img));
% 
% h = plot(perim(:,2),perim(:,1), 'ro');
% set(h, 'linewidth', 2);
% axis('ij')
% hold off;
