% inputs:  an RGB image, state and aspect ratio of ellipse
% This function displays the image converted to grayscale, with the
% ellipse overlayed.
% Actually shows two ellipses, one in red and one in blue
% returns the resulting image that's displayed
function img = show_ellipse_overlayed2(img, state1, state2, aspect_ratio)

color1 = [0 0 255];
color2 = [255 0 0];

% % display image
% clf, colormap(gray)
% imagesc(img);
% hold on

% create binary overlay ellipse perimeter
[perim, mask] = generate_ellipse(size(img), state1, aspect_ratio);
img_perim = zeros(size(img,1), size(img,2));
for i=1:size(perim,1),
    img_perim(perim(i,1), perim(i,2)) = 1;
end
if size(img,1)~=size(img_perim,1) | size(img,2)~=size(img_perim,2),
    error(sprintf('bad size:  %dx%d %dx%d, state=(%d,%d,%d)', size(img,1), size(img_perim,1), size(img,2), size(img_perim,2), state1(1), state1(2), state1(3)));
end

% change pixel values in image
img(:,:,1) = img(:,:,1).*(1-img_perim) + img_perim*color1(1);
img(:,:,2) = img(:,:,2).*(1-img_perim) + img_perim*color1(2);
img(:,:,3) = img(:,:,3).*(1-img_perim) + img_perim*color1(3);

[perim, mask] = generate_ellipse(size(img), state2, aspect_ratio);
img_perim = zeros(size(img,1), size(img,2));
for i=1:size(perim,1),
    img_perim(perim(i,1), perim(i,2)) = 1;
end
if size(img,1)~=size(img_perim,1) | size(img,2)~=size(img_perim,2),
    error(sprintf('bad size:  %dx%d %dx%d, state=(%d,%d,%d)', size(img,1), size(img_perim,1), size(img,2), size(img_perim,2), state2(1), state2(2), state2(3)));
end
img(:,:,1) = img(:,:,1).*(1-img_perim) + img_perim*color2(1);
img(:,:,2) = img(:,:,2).*(1-img_perim) + img_perim*color2(2);
img(:,:,3) = img(:,:,3).*(1-img_perim) + img_perim*color2(3);

clf
imagesc(uint8(img));
% 
% h = plot(perim(:,2),perim(:,1), 'ro');
% set(h, 'linewidth', 2);
% axis('ij')
% hold off;
